<?php
/**
 * OnpointsApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * UV - A Weather Source API
 *
 * Daily and hourly UV data for latitude/longitude points, ZIP/Postal Codes, and Designated Market Areas. UV forecast is up to 5 days out from the current day. Historical UV data is also available. The Weather Source UV API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate analysis. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  **IMPORTANT:** To authenticate to the Weather Source UV API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.27
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * OnpointsApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class OnpointsApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation onpointsOnpointIdDaysDateGet
     *
     * A day of UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $date An date formatted as a RFC3339 date value. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\UvOnpointDayObj
     */
    public function onpointsOnpointIdDaysDateGet($onpoint_id, $date, $fields, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->onpointsOnpointIdDaysDateGetWithHttpInfo($onpoint_id, $date, $fields, $unit_scale);
        return $response;
    }

    /**
     * Operation onpointsOnpointIdDaysDateGetWithHttpInfo
     *
     * A day of UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $date An date formatted as a RFC3339 date value. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\UvOnpointDayObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function onpointsOnpointIdDaysDateGetWithHttpInfo($onpoint_id, $date, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointDayObj';
        $request = $this->onpointsOnpointIdDaysDateGetRequest($onpoint_id, $date, $fields, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\UvOnpointDayObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation onpointsOnpointIdDaysDateGetAsync
     *
     * A day of UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $date An date formatted as a RFC3339 date value. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdDaysDateGetAsync($onpoint_id, $date, $fields, $unit_scale = 'IMPERIAL')
    {
        return $this->onpointsOnpointIdDaysDateGetAsyncWithHttpInfo($onpoint_id, $date, $fields, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation onpointsOnpointIdDaysDateGetAsyncWithHttpInfo
     *
     * A day of UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $date An date formatted as a RFC3339 date value. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdDaysDateGetAsyncWithHttpInfo($onpoint_id, $date, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointDayObj';
        $request = $this->onpointsOnpointIdDaysDateGetRequest($onpoint_id, $date, $fields, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'onpointsOnpointIdDaysDateGet'
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $date An date formatted as a RFC3339 date value. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function onpointsOnpointIdDaysDateGetRequest($onpoint_id, $date, $fields, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'onpoint_id' is set
        if ($onpoint_id === null || (is_array($onpoint_id) && count($onpoint_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $onpoint_id when calling onpointsOnpointIdDaysDateGet'
            );
        }
        // verify the required parameter 'date' is set
        if ($date === null || (is_array($date) && count($date) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $date when calling onpointsOnpointIdDaysDateGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling onpointsOnpointIdDaysDateGet'
            );
        }

        $resourcePath = '/onpoints/{onpointId}/days/{date}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($onpoint_id !== null) {
            $resourcePath = str_replace(
                '{' . 'onpointId' . '}',
                ObjectSerializer::toPathValue($onpoint_id),
                $resourcePath
            );
        }
        // path params
        if ($date !== null) {
            $resourcePath = str_replace(
                '{' . 'date' . '}',
                ObjectSerializer::toPathValue($date),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation onpointsOnpointIdDaysDateStartdateEndGet
     *
     * A contiguous range of daily UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $date_start An date formatted as a RFC3339 date value that must occur temporally before dateEnd. (required)
     * @param  \DateTime $date_end An date formatted as a RFC3339 date value that must occur temporally after dateStart. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\UvOnpointDayObj
     */
    public function onpointsOnpointIdDaysDateStartdateEndGet($onpoint_id, $date_start, $date_end, $fields, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->onpointsOnpointIdDaysDateStartdateEndGetWithHttpInfo($onpoint_id, $date_start, $date_end, $fields, $unit_scale);
        return $response;
    }

    /**
     * Operation onpointsOnpointIdDaysDateStartdateEndGetWithHttpInfo
     *
     * A contiguous range of daily UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $date_start An date formatted as a RFC3339 date value that must occur temporally before dateEnd. (required)
     * @param  \DateTime $date_end An date formatted as a RFC3339 date value that must occur temporally after dateStart. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\UvOnpointDayObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function onpointsOnpointIdDaysDateStartdateEndGetWithHttpInfo($onpoint_id, $date_start, $date_end, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointDayObj';
        $request = $this->onpointsOnpointIdDaysDateStartdateEndGetRequest($onpoint_id, $date_start, $date_end, $fields, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\UvOnpointDayObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation onpointsOnpointIdDaysDateStartdateEndGetAsync
     *
     * A contiguous range of daily UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $date_start An date formatted as a RFC3339 date value that must occur temporally before dateEnd. (required)
     * @param  \DateTime $date_end An date formatted as a RFC3339 date value that must occur temporally after dateStart. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdDaysDateStartdateEndGetAsync($onpoint_id, $date_start, $date_end, $fields, $unit_scale = 'IMPERIAL')
    {
        return $this->onpointsOnpointIdDaysDateStartdateEndGetAsyncWithHttpInfo($onpoint_id, $date_start, $date_end, $fields, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation onpointsOnpointIdDaysDateStartdateEndGetAsyncWithHttpInfo
     *
     * A contiguous range of daily UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $date_start An date formatted as a RFC3339 date value that must occur temporally before dateEnd. (required)
     * @param  \DateTime $date_end An date formatted as a RFC3339 date value that must occur temporally after dateStart. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdDaysDateStartdateEndGetAsyncWithHttpInfo($onpoint_id, $date_start, $date_end, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointDayObj';
        $request = $this->onpointsOnpointIdDaysDateStartdateEndGetRequest($onpoint_id, $date_start, $date_end, $fields, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'onpointsOnpointIdDaysDateStartdateEndGet'
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $date_start An date formatted as a RFC3339 date value that must occur temporally before dateEnd. (required)
     * @param  \DateTime $date_end An date formatted as a RFC3339 date value that must occur temporally after dateStart. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function onpointsOnpointIdDaysDateStartdateEndGetRequest($onpoint_id, $date_start, $date_end, $fields, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'onpoint_id' is set
        if ($onpoint_id === null || (is_array($onpoint_id) && count($onpoint_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $onpoint_id when calling onpointsOnpointIdDaysDateStartdateEndGet'
            );
        }
        // verify the required parameter 'date_start' is set
        if ($date_start === null || (is_array($date_start) && count($date_start) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $date_start when calling onpointsOnpointIdDaysDateStartdateEndGet'
            );
        }
        // verify the required parameter 'date_end' is set
        if ($date_end === null || (is_array($date_end) && count($date_end) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $date_end when calling onpointsOnpointIdDaysDateStartdateEndGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling onpointsOnpointIdDaysDateStartdateEndGet'
            );
        }

        $resourcePath = '/onpoints/{onpointId}/days/{dateStart},{dateEnd}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($onpoint_id !== null) {
            $resourcePath = str_replace(
                '{' . 'onpointId' . '}',
                ObjectSerializer::toPathValue($onpoint_id),
                $resourcePath
            );
        }
        // path params
        if ($date_start !== null) {
            $resourcePath = str_replace(
                '{' . 'dateStart' . '}',
                ObjectSerializer::toPathValue($date_start),
                $resourcePath
            );
        }
        // path params
        if ($date_end !== null) {
            $resourcePath = str_replace(
                '{' . 'dateEnd' . '}',
                ObjectSerializer::toPathValue($date_end),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation onpointsOnpointIdDaysGet
     *
     * The complete daily UV forecast for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\UvOnpointDayObj
     */
    public function onpointsOnpointIdDaysGet($onpoint_id, $fields, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->onpointsOnpointIdDaysGetWithHttpInfo($onpoint_id, $fields, $unit_scale);
        return $response;
    }

    /**
     * Operation onpointsOnpointIdDaysGetWithHttpInfo
     *
     * The complete daily UV forecast for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\UvOnpointDayObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function onpointsOnpointIdDaysGetWithHttpInfo($onpoint_id, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointDayObj';
        $request = $this->onpointsOnpointIdDaysGetRequest($onpoint_id, $fields, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\UvOnpointDayObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation onpointsOnpointIdDaysGetAsync
     *
     * The complete daily UV forecast for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdDaysGetAsync($onpoint_id, $fields, $unit_scale = 'IMPERIAL')
    {
        return $this->onpointsOnpointIdDaysGetAsyncWithHttpInfo($onpoint_id, $fields, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation onpointsOnpointIdDaysGetAsyncWithHttpInfo
     *
     * The complete daily UV forecast for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdDaysGetAsyncWithHttpInfo($onpoint_id, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointDayObj';
        $request = $this->onpointsOnpointIdDaysGetRequest($onpoint_id, $fields, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'onpointsOnpointIdDaysGet'
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function onpointsOnpointIdDaysGetRequest($onpoint_id, $fields, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'onpoint_id' is set
        if ($onpoint_id === null || (is_array($onpoint_id) && count($onpoint_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $onpoint_id when calling onpointsOnpointIdDaysGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling onpointsOnpointIdDaysGet'
            );
        }

        $resourcePath = '/onpoints/{onpointId}/days';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($onpoint_id !== null) {
            $resourcePath = str_replace(
                '{' . 'onpointId' . '}',
                ObjectSerializer::toPathValue($onpoint_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation onpointsOnpointIdHoursGet
     *
     * The complete hourly UV forecast for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\UvOnpointHourObj
     */
    public function onpointsOnpointIdHoursGet($onpoint_id, $fields, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->onpointsOnpointIdHoursGetWithHttpInfo($onpoint_id, $fields, $unit_scale);
        return $response;
    }

    /**
     * Operation onpointsOnpointIdHoursGetWithHttpInfo
     *
     * The complete hourly UV forecast for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\UvOnpointHourObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function onpointsOnpointIdHoursGetWithHttpInfo($onpoint_id, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointHourObj';
        $request = $this->onpointsOnpointIdHoursGetRequest($onpoint_id, $fields, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\UvOnpointHourObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation onpointsOnpointIdHoursGetAsync
     *
     * The complete hourly UV forecast for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHoursGetAsync($onpoint_id, $fields, $unit_scale = 'IMPERIAL')
    {
        return $this->onpointsOnpointIdHoursGetAsyncWithHttpInfo($onpoint_id, $fields, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation onpointsOnpointIdHoursGetAsyncWithHttpInfo
     *
     * The complete hourly UV forecast for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHoursGetAsyncWithHttpInfo($onpoint_id, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointHourObj';
        $request = $this->onpointsOnpointIdHoursGetRequest($onpoint_id, $fields, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'onpointsOnpointIdHoursGet'
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function onpointsOnpointIdHoursGetRequest($onpoint_id, $fields, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'onpoint_id' is set
        if ($onpoint_id === null || (is_array($onpoint_id) && count($onpoint_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $onpoint_id when calling onpointsOnpointIdHoursGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling onpointsOnpointIdHoursGet'
            );
        }

        $resourcePath = '/onpoints/{onpointId}/hours';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($onpoint_id !== null) {
            $resourcePath = str_replace(
                '{' . 'onpointId' . '}',
                ObjectSerializer::toPathValue($onpoint_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation onpointsOnpointIdHoursTimestampGet
     *
     * An hour of UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\UvOnpointHourObj
     */
    public function onpointsOnpointIdHoursTimestampGet($onpoint_id, $timestamp, $fields, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->onpointsOnpointIdHoursTimestampGetWithHttpInfo($onpoint_id, $timestamp, $fields, $unit_scale);
        return $response;
    }

    /**
     * Operation onpointsOnpointIdHoursTimestampGetWithHttpInfo
     *
     * An hour of UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\UvOnpointHourObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function onpointsOnpointIdHoursTimestampGetWithHttpInfo($onpoint_id, $timestamp, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointHourObj';
        $request = $this->onpointsOnpointIdHoursTimestampGetRequest($onpoint_id, $timestamp, $fields, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\UvOnpointHourObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation onpointsOnpointIdHoursTimestampGetAsync
     *
     * An hour of UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHoursTimestampGetAsync($onpoint_id, $timestamp, $fields, $unit_scale = 'IMPERIAL')
    {
        return $this->onpointsOnpointIdHoursTimestampGetAsyncWithHttpInfo($onpoint_id, $timestamp, $fields, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation onpointsOnpointIdHoursTimestampGetAsyncWithHttpInfo
     *
     * An hour of UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHoursTimestampGetAsyncWithHttpInfo($onpoint_id, $timestamp, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointHourObj';
        $request = $this->onpointsOnpointIdHoursTimestampGetRequest($onpoint_id, $timestamp, $fields, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'onpointsOnpointIdHoursTimestampGet'
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function onpointsOnpointIdHoursTimestampGetRequest($onpoint_id, $timestamp, $fields, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'onpoint_id' is set
        if ($onpoint_id === null || (is_array($onpoint_id) && count($onpoint_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $onpoint_id when calling onpointsOnpointIdHoursTimestampGet'
            );
        }
        // verify the required parameter 'timestamp' is set
        if ($timestamp === null || (is_array($timestamp) && count($timestamp) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $timestamp when calling onpointsOnpointIdHoursTimestampGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling onpointsOnpointIdHoursTimestampGet'
            );
        }

        $resourcePath = '/onpoints/{onpointId}/hours/{timestamp}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($onpoint_id !== null) {
            $resourcePath = str_replace(
                '{' . 'onpointId' . '}',
                ObjectSerializer::toPathValue($onpoint_id),
                $resourcePath
            );
        }
        // path params
        if ($timestamp !== null) {
            $resourcePath = str_replace(
                '{' . 'timestamp' . '}',
                ObjectSerializer::toPathValue($timestamp),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation onpointsOnpointIdHoursTimestampStarttimestampEndGet
     *
     * A contiguous range of hourly UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\UvOnpointHourObj
     */
    public function onpointsOnpointIdHoursTimestampStarttimestampEndGet($onpoint_id, $timestamp_start, $timestamp_end, $fields, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->onpointsOnpointIdHoursTimestampStarttimestampEndGetWithHttpInfo($onpoint_id, $timestamp_start, $timestamp_end, $fields, $unit_scale);
        return $response;
    }

    /**
     * Operation onpointsOnpointIdHoursTimestampStarttimestampEndGetWithHttpInfo
     *
     * A contiguous range of hourly UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\UvOnpointHourObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function onpointsOnpointIdHoursTimestampStarttimestampEndGetWithHttpInfo($onpoint_id, $timestamp_start, $timestamp_end, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointHourObj';
        $request = $this->onpointsOnpointIdHoursTimestampStarttimestampEndGetRequest($onpoint_id, $timestamp_start, $timestamp_end, $fields, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\UvOnpointHourObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation onpointsOnpointIdHoursTimestampStarttimestampEndGetAsync
     *
     * A contiguous range of hourly UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHoursTimestampStarttimestampEndGetAsync($onpoint_id, $timestamp_start, $timestamp_end, $fields, $unit_scale = 'IMPERIAL')
    {
        return $this->onpointsOnpointIdHoursTimestampStarttimestampEndGetAsyncWithHttpInfo($onpoint_id, $timestamp_start, $timestamp_end, $fields, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation onpointsOnpointIdHoursTimestampStarttimestampEndGetAsyncWithHttpInfo
     *
     * A contiguous range of hourly UV data for an OnPoint™ point.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHoursTimestampStarttimestampEndGetAsyncWithHttpInfo($onpoint_id, $timestamp_start, $timestamp_end, $fields, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\UvOnpointHourObj';
        $request = $this->onpointsOnpointIdHoursTimestampStarttimestampEndGetRequest($onpoint_id, $timestamp_start, $timestamp_end, $fields, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'onpointsOnpointIdHoursTimestampStarttimestampEndGet'
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function onpointsOnpointIdHoursTimestampStarttimestampEndGetRequest($onpoint_id, $timestamp_start, $timestamp_end, $fields, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'onpoint_id' is set
        if ($onpoint_id === null || (is_array($onpoint_id) && count($onpoint_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $onpoint_id when calling onpointsOnpointIdHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'timestamp_start' is set
        if ($timestamp_start === null || (is_array($timestamp_start) && count($timestamp_start) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $timestamp_start when calling onpointsOnpointIdHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'timestamp_end' is set
        if ($timestamp_end === null || (is_array($timestamp_end) && count($timestamp_end) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $timestamp_end when calling onpointsOnpointIdHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling onpointsOnpointIdHoursTimestampStarttimestampEndGet'
            );
        }

        $resourcePath = '/onpoints/{onpointId}/hours/{timestampStart},{timestampEnd}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($onpoint_id !== null) {
            $resourcePath = str_replace(
                '{' . 'onpointId' . '}',
                ObjectSerializer::toPathValue($onpoint_id),
                $resourcePath
            );
        }
        // path params
        if ($timestamp_start !== null) {
            $resourcePath = str_replace(
                '{' . 'timestampStart' . '}',
                ObjectSerializer::toPathValue($timestamp_start),
                $resourcePath
            );
        }
        // path params
        if ($timestamp_end !== null) {
            $resourcePath = str_replace(
                '{' . 'timestampEnd' . '}',
                ObjectSerializer::toPathValue($timestamp_end),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
