<?php
/**
 * DmaObj
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * UV - A Weather Source API
 *
 * Daily and hourly UV data for latitude/longitude points, ZIP/Postal Codes, and Designated Market Areas. UV forecast is up to 5 days out from the current day. Historical UV data is also available. The Weather Source UV API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate analysis. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  **IMPORTANT:** To authenticate to the Weather Source UV API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.27
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * DmaObj Class Doc Comment
 *
 * @category Class
 * @description A Designated Market Area location metadata object
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class DmaObj implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'dmaObj';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'dma_id' => '\Swagger\Client\Model\DmaId',
'dma_name' => '\Swagger\Client\Model\DmaName',
'timezone' => '\Swagger\Client\Model\Timezone',
'population' => '\Swagger\Client\Model\Population',
'country_code' => '\Swagger\Client\Model\CountryCode',
'country_name' => '\Swagger\Client\Model\CountryName',
'sample_points' => '\Swagger\Client\Model\SamplePoints',
'grid' => '\Swagger\Client\Model\Grid'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'dma_id' => null,
'dma_name' => null,
'timezone' => null,
'population' => null,
'country_code' => null,
'country_name' => null,
'sample_points' => null,
'grid' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'dma_id' => 'dmaId',
'dma_name' => 'dmaName',
'timezone' => 'timezone',
'population' => 'population',
'country_code' => 'countryCode',
'country_name' => 'countryName',
'sample_points' => 'samplePoints',
'grid' => 'grid'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'dma_id' => 'setDmaId',
'dma_name' => 'setDmaName',
'timezone' => 'setTimezone',
'population' => 'setPopulation',
'country_code' => 'setCountryCode',
'country_name' => 'setCountryName',
'sample_points' => 'setSamplePoints',
'grid' => 'setGrid'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'dma_id' => 'getDmaId',
'dma_name' => 'getDmaName',
'timezone' => 'getTimezone',
'population' => 'getPopulation',
'country_code' => 'getCountryCode',
'country_name' => 'getCountryName',
'sample_points' => 'getSamplePoints',
'grid' => 'getGrid'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['dma_id'] = isset($data['dma_id']) ? $data['dma_id'] : null;
        $this->container['dma_name'] = isset($data['dma_name']) ? $data['dma_name'] : null;
        $this->container['timezone'] = isset($data['timezone']) ? $data['timezone'] : null;
        $this->container['population'] = isset($data['population']) ? $data['population'] : null;
        $this->container['country_code'] = isset($data['country_code']) ? $data['country_code'] : null;
        $this->container['country_name'] = isset($data['country_name']) ? $data['country_name'] : null;
        $this->container['sample_points'] = isset($data['sample_points']) ? $data['sample_points'] : null;
        $this->container['grid'] = isset($data['grid']) ? $data['grid'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['dma_id'] === null) {
            $invalidProperties[] = "'dma_id' can't be null";
        }
        if ($this->container['dma_name'] === null) {
            $invalidProperties[] = "'dma_name' can't be null";
        }
        if ($this->container['timezone'] === null) {
            $invalidProperties[] = "'timezone' can't be null";
        }
        if ($this->container['population'] === null) {
            $invalidProperties[] = "'population' can't be null";
        }
        if ($this->container['country_code'] === null) {
            $invalidProperties[] = "'country_code' can't be null";
        }
        if ($this->container['country_name'] === null) {
            $invalidProperties[] = "'country_name' can't be null";
        }
        if ($this->container['sample_points'] === null) {
            $invalidProperties[] = "'sample_points' can't be null";
        }
        if ($this->container['grid'] === null) {
            $invalidProperties[] = "'grid' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets dma_id
     *
     * @return \Swagger\Client\Model\DmaId
     */
    public function getDmaId()
    {
        return $this->container['dma_id'];
    }

    /**
     * Sets dma_id
     *
     * @param \Swagger\Client\Model\DmaId $dma_id dma_id
     *
     * @return $this
     */
    public function setDmaId($dma_id)
    {
        $this->container['dma_id'] = $dma_id;

        return $this;
    }

    /**
     * Gets dma_name
     *
     * @return \Swagger\Client\Model\DmaName
     */
    public function getDmaName()
    {
        return $this->container['dma_name'];
    }

    /**
     * Sets dma_name
     *
     * @param \Swagger\Client\Model\DmaName $dma_name dma_name
     *
     * @return $this
     */
    public function setDmaName($dma_name)
    {
        $this->container['dma_name'] = $dma_name;

        return $this;
    }

    /**
     * Gets timezone
     *
     * @return \Swagger\Client\Model\Timezone
     */
    public function getTimezone()
    {
        return $this->container['timezone'];
    }

    /**
     * Sets timezone
     *
     * @param \Swagger\Client\Model\Timezone $timezone timezone
     *
     * @return $this
     */
    public function setTimezone($timezone)
    {
        $this->container['timezone'] = $timezone;

        return $this;
    }

    /**
     * Gets population
     *
     * @return \Swagger\Client\Model\Population
     */
    public function getPopulation()
    {
        return $this->container['population'];
    }

    /**
     * Sets population
     *
     * @param \Swagger\Client\Model\Population $population population
     *
     * @return $this
     */
    public function setPopulation($population)
    {
        $this->container['population'] = $population;

        return $this;
    }

    /**
     * Gets country_code
     *
     * @return \Swagger\Client\Model\CountryCode
     */
    public function getCountryCode()
    {
        return $this->container['country_code'];
    }

    /**
     * Sets country_code
     *
     * @param \Swagger\Client\Model\CountryCode $country_code country_code
     *
     * @return $this
     */
    public function setCountryCode($country_code)
    {
        $this->container['country_code'] = $country_code;

        return $this;
    }

    /**
     * Gets country_name
     *
     * @return \Swagger\Client\Model\CountryName
     */
    public function getCountryName()
    {
        return $this->container['country_name'];
    }

    /**
     * Sets country_name
     *
     * @param \Swagger\Client\Model\CountryName $country_name country_name
     *
     * @return $this
     */
    public function setCountryName($country_name)
    {
        $this->container['country_name'] = $country_name;

        return $this;
    }

    /**
     * Gets sample_points
     *
     * @return \Swagger\Client\Model\SamplePoints
     */
    public function getSamplePoints()
    {
        return $this->container['sample_points'];
    }

    /**
     * Sets sample_points
     *
     * @param \Swagger\Client\Model\SamplePoints $sample_points sample_points
     *
     * @return $this
     */
    public function setSamplePoints($sample_points)
    {
        $this->container['sample_points'] = $sample_points;

        return $this;
    }

    /**
     * Gets grid
     *
     * @return \Swagger\Client\Model\Grid
     */
    public function getGrid()
    {
        return $this->container['grid'];
    }

    /**
     * Sets grid
     *
     * @param \Swagger\Client\Model\Grid $grid grid
     *
     * @return $this
     */
    public function setGrid($grid)
    {
        $this->container['grid'] = $grid;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
