<?php
/**
 * PostcodesApiTest
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * UV - A Weather Source API
 *
 * Daily and hourly UV data for latitude/longitude points, ZIP/Postal Codes, and Designated Market Areas. UV forecast is up to 5 days out from the current day. Historical UV data is also available. The Weather Source UV API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate analysis. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  **IMPORTANT:** To authenticate to the Weather Source UV API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.27
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Please update the test case below to test the endpoint.
 */

namespace Swagger\Client;

use Swagger\Client\Configuration;
use Swagger\Client\ApiException;
use Swagger\Client\ObjectSerializer;

/**
 * PostcodesApiTest Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class PostcodesApiTest extends \PHPUnit_Framework_TestCase
{

    /**
     * Setup before running any test cases
     */
    public static function setUpBeforeClass()
    {
    }

    /**
     * Setup before running each test case
     */
    public function setUp()
    {
    }

    /**
     * Clean up after running each test case
     */
    public function tearDown()
    {
    }

    /**
     * Clean up after running all test cases
     */
    public static function tearDownAfterClass()
    {
    }

    /**
     * Test case for postcodesPostcodecountryCodeDaysDateGet
     *
     * A day of UV data for a postcode..
     *
     */
    public function testPostcodesPostcodecountryCodeDaysDateGet()
    {
    }

    /**
     * Test case for postcodesPostcodecountryCodeDaysDateStartdateEndGet
     *
     * A contiguous range of daily UV data for a postcode..
     *
     */
    public function testPostcodesPostcodecountryCodeDaysDateStartdateEndGet()
    {
    }

    /**
     * Test case for postcodesPostcodecountryCodeDaysGet
     *
     * The complete daily UV forecast for a postcode..
     *
     */
    public function testPostcodesPostcodecountryCodeDaysGet()
    {
    }

    /**
     * Test case for postcodesPostcodecountryCodeHoursGet
     *
     * The complete hourly UV forecast for a postcode..
     *
     */
    public function testPostcodesPostcodecountryCodeHoursGet()
    {
    }

    /**
     * Test case for postcodesPostcodecountryCodeHoursTimestampGet
     *
     * An hour of UV data for a postcode..
     *
     */
    public function testPostcodesPostcodecountryCodeHoursTimestampGet()
    {
    }

    /**
     * Test case for postcodesPostcodecountryCodeHoursTimestampStarttimestampEndGet
     *
     * A contiguous range of hourly UV data for a postcode..
     *
     */
    public function testPostcodesPostcodecountryCodeHoursTimestampStarttimestampEndGet()
    {
    }
}
